---
title: Dominators view
slug: Tools/Memory/Dominators_view
---
<div>{{ToolsSidebar}}</div><div class="geckoVersionNote">
<p>The Dominators view is new in Firefox 46.</p>
</div>

<p>Starting in Firefox 46, the Memory tool includes a new view called the Dominators view. This is useful for understanding the "retained size" of objects allocated by your site: that is, the size of the objects themselves plus the size of the objects that they keep alive through references.</p>

<p>If you already know what shallow size, retained size, and dominators are, skip to the Dominators UI section. Otherwise, you might want to review the article on <a href="/en-US/docs/Tools/Memory/Dominators">Dominators concepts</a>.</p>

<h2 id="Dominators_UI">Dominators UI</h2>

<p>To see the Dominators view for a snapshot, select "Dominators" in the "View" drop-down list. It looks something like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13627/dominators-1.png" style="display: block; height: 230px; margin: 0px auto; width: 800px;"></p>

<p>The Dominators view consists of two panels:</p>

<ul>
 <li>the <a href="/en-US/docs/Tools/Memory/Dominators_view#Dominators_Tree_panel">Dominators Tree panel</a> shows you which nodes in the snapshot are retaining the most memory</li>
 <li>the <a href="/en-US/docs/Tools/Memory/Dominators_view#Retaining_Paths_panel">Retaining Paths panel</a> (new in Firefox 47) shows the 5 shortest retaining paths for a single node.</li>
</ul>

<p><img alt="" src="https://mdn.mozillademos.org/files/13629/dominators-2.png" style="display: block; margin: 0px auto;"></p>

<h3 id="Dominators_Tree_panel">Dominators Tree panel</h3>

<p>The Dominators Tree tells you which objects in the snapshot are retaining the most memory.</p>

<p>In the main part of the UI, the first row is labeled "GC Roots". Immediately underneath that is an entry for:</p>

<ul>
 <li>Every GC root node. In Gecko, there is more than one memory graph, and therefore more than one root. There may be many (often temporary) roots. For example: variables allocated on the stack need to be rooted, or internal caches may need to root their elements.</li>
 <li>Any other node that's referenced from two different roots (since in this case, neither root dominates it).</li>
</ul>

<p>Each entry displays:</p>

<ul>
 <li>the retained size of the node, as bytes and as a percentage of the total</li>
 <li>the shallow size of the node, as bytes and as a percentage of the total</li>
 <li>the nodes's name and address in memory.</li>
</ul>

<p>Entries are ordered by the amount of memory that they retain. For example:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13631/dominators-3.png" style="display: block; height: 228px; margin: 0px auto; width: 700px;"></p>

<p>In this screenshot we can see five entries under "GC Roots". The first two are Call and Window objects, and retain about 21% and 8% of the total size of the memory snapshot, respectively. You can also see that these objects have a relatively tiny "Shallow Size", so almost all of the retained size is in the objects that they dominate.</p>

<p>Immediately under each GC root, you'll see all the nodes for which this root is the <a href="/en-US/docs/Tools/Memory/Dominators#immediate_dominator">immediate dominator</a>. These nodes are also ordered by their retained size.</p>

<p>For example, if we click on the first Window object:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13633/dominators-4.png" style="display: block; height: 292px; margin: 0px auto; width: 700px;"></p>

<p>We can see that this Window dominates a CSS2Properties object, whose retained size is 2% of the total snapshot size. Again the shallow size is very small: almost all of its retained size is in the nodes that it dominates. By clicking on the disclosure arrow next to the Function, we can see those nodes.</p>

<p>In this way you can quickly get a sense of which objects retain the most memory in the snapshot.</p>

<p>You can use <kbd>Alt</kbd> + click to expand the whole graph under a node.</p>

<h4 id="Call_Stack">Call Stack</h4>

<p>In the toolbar at the top of the tool is a dropdown called "Label by":</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13635/dominators-5.png" style="display: block; height: 224px; margin: 0px auto; width: 800px;"></p>

<p>By default, this is set to "Type". However, you can set it instead to "Call Stack" to see exactly where in your code the objects are being allocated.</p>

<div class="note">
<p>This option is called "Allocation Stack" in Firefox 46.</p>
</div>

<p>To enable this, you must check the box labeled "Record call stacks" <em>before</em> you run the code that allocates the objects. Then take a snapshot, then select "Call Stack" in the "Label by" drop-down.</p>

<p>Now the node's name will contain the name of the function that allocated it, and the file, line number and character position of the exact spot where the function allocated it. Clicking the file name will take you to that spot in the Debugger.</p>

<p>{{EmbedYouTube("qTF5wCSD124")}}</p>

<div class="note">
<p>Sometimes you'll see "(no stack available)" here. In particular, allocation stacks are currently only recorded for objects, not for arrays, strings, or internal structures.</p>
</div>

<h3 id="Retaining_Paths_panel">Retaining Paths panel</h3>

<div class="geckoVersionNote">The Retaining Paths panel is new in Firefox 47.</div>

<p>The Retaining Paths panel shows you, for a given node, the 5 shortest paths back from this node to a GC root. This enables you to see all the nodes that are keeping the given node from being garbage-collected. If you suspect that an object is being leaked, this will show you exactly which objects are holding a reference to it.</p>

<p>To see the retaining paths for a node, you have to select the node in the Dominators Tree panel:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13637/dominators-6.png" style="display: block; height: 415px; margin: 0px auto; width: 800px;"></p>

<p>Here, we've selected an object, and can see a single path back to a GC root.</p>

<p>The <code>Window</code> GC root holds a reference to an <code>HTMLDivElement</code> object, and that holds a reference to an <code>Object</code>, and so on. If you look in the Dominators Tree panel, you can trace the same path there. If either of these references were removed, the items below them could be garbage-collected.</p>

<p>Each connection in the graph is labeled with the variable name for the referenced object.</p>

<p>Sometimes there's more than one retaining path back from a node:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13639/dominators-7.png" style="display: block; height: 455px; margin: 0px auto; width: 700px;"></p>

<p>Here there are three paths back from the <code>DocumentPrototype</code> node to a GC root. If one were removed, then the <code>DocumentPrototype</code> would still not be garbage-collected, because it's still retained by the other two path.</p>

<h2 id="Example">Example</h2>

<p>Let's see how some simple code is reflected in the Dominators view.</p>

<p>We'll use the <a href="/en-US/docs/Tools/Memory/Monster_example">monster allocation example</a>, which creates three arrays, each containing 5000 monsters, each monster having a randomly-generated name.</p>

<h3 id="Taking_a_snapshot">Taking a snapshot</h3>

<p>To see what it looks like in the Dominators view:</p>

<ul>
 <li>load the page</li>
 <li>enable the Memory tool in the <a href="/en-US/docs/Tools/Tools_Toolbox#Settings">Settings</a>, if you haven't already</li>
 <li>open the Memory tool</li>
 <li>check "Record call stacks"</li>
 <li>press the button labeled "Make monsters!"</li>
 <li>take a snapshot</li>
 <li>switch to the "Dominators" view</li>
</ul>

<p>{{EmbedYouTube("HiWnfMoMs2c")}}</p>

<h3 id="Analyzing_the_Dominators_Tree">Analyzing the Dominators Tree</h3>

<p>You'll see the three arrays as the top three GC roots, each retaining about 23% of the total memory usage:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13641/dominators-8.png" style="display: block; height: 165px; margin: 0px auto; width: 700px;"></p>

<p>If you expand an array, you'll see the objects (monsters) it contains. Each monster has a relatively small shallow size of 160 bytes. This includes the integer eye- and tentacle-counts. Each monster has a bigger retained size, which is accounted for by the string used for the monster's name:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13643/dominators-9.png" style="display: block; height: 327px; margin: 0px auto; width: 700px;"></p>

<p>All this maps closely to the <a href="/en-US/docs/Tools/Memory/Monster_example#allocation-graph">memory graph we were expecting to see</a>. One thing you might be wondering, though, is: where's the top-level object that retains all three arrays? If we look at the Retaining Paths panel for one of the arrays, we'll see it:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13645/dominators-10.png" style="display: block; height: 467px; margin: 0px auto; width: 700px;"></p>

<p>Here we can see the retaining object, and even that this particular array is the array of <code>fierce</code> monsters. But the array is also rooted directly, so if the object were to stop referencing the array, it would still not be eligible for garbage collection.</p>

<p>This means that the object does not dominate the array, and is therefore not shown in the Dominators Tree view. <a href="/en-US/docs/Tools/Memory/Dominators#multiple-paths">See the relevant section of the Dominators concepts article</a>.</p>

<h3 id="Using_the_Call_Stack_view">Using the Call Stack view</h3>

<p>Finally, you can switch to the Call Stack view, see where the objects are being allocated, and jump to that point in the Debugger:</p>

<p>{{EmbedYouTube("qTF5wCSD124")}}</p>
